# Extract from XLSM

Use this extractor for `.xlsm` files. It can extract images, worksheets, audio, video, embedded files into a ZIP result.

## Quick reference

| Field | Value |
| --- | --- |
| Source file type | `.xlsm` |
| Source group | Documents |
| Submit endpoint | `POST https://api.tools.fast/extract` |
| Estimate endpoint | `POST https://api.tools.fast/extract/estimate/xlsm` |
| Result | ZIP download |
| Default capabilities | `excel.images`, `excel.worksheets`, `excel.audio`, `excel.video`, `excel.embeddedFiles` |
| Max file size | free: 50 MB; pro: 2048 MB |
| Document limits | free: 2000 document units; pro: 2000 document units |
| Duration limits | Not applicable |

## Capabilities

| Capability | Default | Options | Pricing | Description |
| --- | --- | --- | --- | --- |
| `excel.images` | Yes | None | Included | Original image assets saved as separate files. |
| `excel.worksheets` | Yes | None | Included | Worksheet CSV files for analysis or migration. |
| `excel.audio` | Yes | `audioFormat` | Included | Extracted audio files when present. |
| `excel.video` | Yes | None | Included | Extracted video files when present. |
| `excel.embeddedFiles` | Yes | None | Included | Embedded files recovered as separate files. |


## Capability options

### Audio

| Option | Type | Default | Allowed values | Limits |
| --- | --- | --- | --- | --- |
| `audioFormat` | `enum` | `mp3` | `mp3`, `wav`, `m4a`, `original`, `best` | None |

## Options payload with all capabilities

Use this shape when you want to explicitly configure every supported output for this source type.

```json
{
  "extraction": {
    "selectedCapabilities": [
      "excel.images",
      "excel.worksheets",
      "excel.audio",
      "excel.video",
      "excel.embeddedFiles"
    ],
    "includeManifest": true,
    "capabilityOptions": {
      "excel.audio": {
        "audioFormat": "mp3"
      }
    }
  }
}
```

## Estimate example

```bash
curl -sS -X POST "https://api.tools.fast/extract/estimate/xlsm" \
  -H "X-Fast-Api-Key: $API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
  "fileSizeMb": 10,
  "sheetCount": 12,
  "options": {
    "extraction": {
      "selectedCapabilities": [
        "excel.images",
        "excel.worksheets",
        "excel.audio",
        "excel.video",
        "excel.embeddedFiles"
      ],
      "includeManifest": true,
      "capabilityOptions": {
        "excel.audio": {
          "audioFormat": "mp3"
        }
      }
    }
  }
}'
```

## Extract example with all options configured

```bash
curl -sS -X POST "https://api.tools.fast/extract" \
  -H "X-Fast-Api-Key: $API_KEY" \
  -F "file=@input.xlsm" \
  -F 'options={
  "extraction": {
    "selectedCapabilities": [
      "excel.images",
      "excel.worksheets",
      "excel.audio",
      "excel.video",
      "excel.embeddedFiles"
    ],
    "includeManifest": true,
    "capabilityOptions": {
      "excel.audio": {
        "audioFormat": "mp3"
      }
    }
  }
}'
```

## Machine-readable discovery

```http
GET /options/xlsm
GET /extractors/xlsm
```
